
local o = SimpleDruidBar; if (o == nil) then return; end

-- Display_t_Init: ()
--
-- Display_OnEvent_UNIT_MANA: -- (unit)
-- Display_OnEvent_UNIT_DISPLAYPOWER: -- (unit)
--
-- Display_DisplayBar_OnDragStop: (self)
-- Display_DisplayBar_OnEvent: (self, event, unit)
-- Display_t_LoadBar: bar = ()

-- Display_DISPLAY_BAR = nil;

-- Display_maxMana = nil;




function o.Display_t_Init()
	o.Display_t_Init = nil;
	
	o.Display_t_LoadBar();
end




do
	local UnitPower = UnitPower;
	
	function o.Display_OnEvent_UNIT_MANA(unit)
		if (unit ~= "player") then
			return;
		end
		
		local bar = o.Display_DISPLAY_BAR;
		local currMana = UnitPower("player", 0);
		bar:SetValue(currMana);
		bar.TEXT:SetFormattedText("%d / %d", currMana, o.Display_maxMana);
	end
end



do
	local UnitPowerMax = UnitPowerMax;
	
	function o.Display_OnEvent_UNIT_MAXMANA(unit)
		if (unit ~= "player") then
			return;
		end
		
		local maxMana = UnitPowerMax("player", 0);
		o.Display_maxMana = maxMana;
		o.Display_DISPLAY_BAR:SetMinMaxValues(0, maxMana);
	end
end



function o.Display_OnEvent_UNIT_DISPLAYPOWER(unit)
	if (unit ~= "player") then
		return;
	end
	
	if (UnitPowerType("player") == 0) then
		o.Display_DISPLAY_BAR:UnregisterEvent("UNIT_MANA");
		o.Display_DISPLAY_BAR:UnregisterEvent("UNIT_MAXMANA");
		o.Display_DISPLAY_BAR:Hide();
	else
		o.Display_DISPLAY_BAR:RegisterEvent("UNIT_MANA");
		o.Display_DISPLAY_BAR:RegisterEvent("UNIT_MAXMANA");
		o.Display_OnEvent_UNIT_MAXMANA("player");
		o.Display_OnEvent_UNIT_MANA("player");
		o.Display_DISPLAY_BAR:Show();
	end
end




function o.Display_DisplayBar_OnDragStop(self)
	self:StopMovingOrSizing();
	SimpleDruidBar_Config.offsetX, SimpleDruidBar_Config.offsetY = self:GetCenter();
end



function o.Display_DisplayBar_OnEvent(self, event, unit)
	if (event == "UNIT_MANA") then
		o.Display_OnEvent_UNIT_MANA(unit);
	elseif (event == "UNIT_DISPLAYPOWER") then
		o.Display_OnEvent_UNIT_DISPLAYPOWER(unit);
	elseif (event == "UNIT_MAXMANA") then
		o.Display_OnEvent_UNIT_MAXMANA(unit);
	elseif (event == "VARIABLES_LOADED") then
		o.Config_OnEvent_VARIABLES_LOADED();
	end
end



function o.Display_t_LoadBar()
	o.Display_t_LoadBar = nil;
	
	local bar = CreateFrame("StatusBar", "SimpleDruidBar_DisplayBar", UIParent, nil);
	o.Display_DISPLAY_BAR = bar;
	bar:Hide();
	bar:SetFrameStrata("LOW");
	bar:SetWidth(120);
	bar:SetHeight(14);
	bar:SetAlpha(1.0);
	bar:SetMovable(true);
	bar:EnableMouse(true);
	bar:RegisterForDrag("LeftButton", "RightButton");
	bar:SetScript("OnDragStart", bar.StartMoving);
	bar:SetScript("OnDragStop", o.Display_DisplayBar_OnDragStop);
	bar:SetStatusBarTexture("Interface/TargetingFrame/UI-StatusBar");
	bar:SetStatusBarColor(0.0, 0.0, 1.0);
	bar:SetScript("OnEvent", o.Display_DisplayBar_OnEvent);
	bar:RegisterEvent("UNIT_DISPLAYPOWER");
	bar:SetScript("OnUpdate", o.Display_DisplayBar_OnUpdate);
	
	local barText = bar:CreateFontString("SimpleDruidBar_DisplayBarText", "OVERLAY", nil);
	barText:SetPoint("CENTER", bar, "CENTER", 0, 0);
	barText:SetJustifyH("CENTER");
	bar.TEXT = barText;
	
	local border = bar:CreateTexture("SimpleDruidBar_DisplayBarBorder", "OVERLAY", nil);
	border:Show();
	border:SetTexture("Interface/Tooltips/UI-StatusBar-Border");
	
	local backdrop = bar:CreateTexture("SimpleDruidBar_DisplayBarBackdrop", "BACKGROUND", nil);
	backdrop:Show();
	backdrop:SetAllPoints(bar);
	backdrop:SetTexture(0.2, 0.2, 0.2, 1.0);
	
	return bar;
end
